// Beispiel 7.6A
/* Anwendung von Klassen */
#include <graphics.h>
#include <dos.h>
const char BGI[ ]="c:\\bc\\bgi";

class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y)
      {xx=x; yy=y;};
    int x() {return xx;};
    int y() {return yy;};
}; // Ort

class Pixel: public Ort
{ protected:
    int ff;
  public:
    Pixel(int x,int y,int f=getmaxcolor());
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    virtual void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

class Kreis: public Pixel
{ protected:
    int rr;
  public:
    Kreis (int x,int y,
      int f=getmaxcolor(),int r=10):
      Pixel(x,y,f),rr(r) { };
    int r() {return rr;};
    virtual void zeichnen(int sichtbar);
}; // Kreis

class Quadrat: public Pixel
{ protected:
    int ss;
  public:
    Quadrat(int,int,int,int);
    int s() {return ss;};
    void zeichnen(int);
}; // Quadrat

class Strecke: public Pixel
{ protected:
    Ort endp;
  public:
    Strecke(int,int,int,int,int);
    void bewegen(int dx=1,int dy=1);
    virtual void zeichnen(int sichtbar);
}; // Strecke

// ********** Implementierung von Pixel ********

Pixel::Pixel(int x,int y,int f): Ort(x,y),ff(f)
{ } // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

// ********** Implementierung von Kreis ********

void Kreis::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  circle(xx,yy,rr);
} // Kreis::zeichnen

// ********** Implementierung von Quadrat ******
Quadrat::Quadrat(int x,int y,int f,int s):
  Pixel(x,y,f)
{ ss=s;
} // Quadrat::Quadrat

void Quadrat::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  int ss2=ss/2;
  moveto(xx-ss2,yy-ss2);
  lineto(xx+ss2,yy-ss2);
  lineto(xx+ss2,yy+ss2);
  lineto(xx-ss2,yy+ss2);
  lineto(xx-ss2,yy-ss2);
} // Quadrat::zeichnen

// ****Implementierung von Strecke*********
Strecke::Strecke(int xa,int ya,int f,
  int xe,int ye):
  Pixel(xa,ya,f),endp(xe,ye)
{ } // Strecke::Strecke

void Strecke::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  moveto(x(),y());
  lineto(endp.x(),endp.y());
} // Strecke::zeichnen

void Strecke::bewegen(int dx,int dy)
{ zeichnen(0);  // verstecke dich!
  xysetzen(x()+dx,y()+dy);
  endp.xysetzen(endp.x()+dx,endp.y()+dy);
  zeichnen(1);  // zeige dich!
} // Strecke::bewegen

// ********** Hauptprogramm ********************

void main()
{ int karte=DETECT,modus,i;
  initgraph(&karte,&modus,BGI);
  Strecke s(25,25,getmaxcolor(),80,10);
  s.zeichnen(1);
  for (i=1;i<=150;i++)
  { s.bewegen(1,1);
    delay(100);
  }
  closegraph();
} // b076a
