// Beispiel 7.6C
/* Mehrfachvererbung */
#include <graphics.h>
#include <dos.h>
const char BGI[ ]="c:\\bc\\bgi";

class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y)
      {xx=x; yy=y;};
    int x() {return xx;};
    int y() {return yy;};
}; // Ort

class Pixel: public Ort
{ protected:
    int ff;
  public:
    Pixel(int x,int y,int f=getmaxcolor());
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    virtual void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

class Kreis: virtual public Pixel
{ protected:
    int rr;
  public:
    Kreis (int x,int y,
      int f=getmaxcolor(),int r=10):
      Pixel(x,y,f),rr(r) { };
    int r() {return rr;};
    void zeichnen(int sichtbar);
}; // Kreis

class Quadrat: virtual public Pixel
{ protected:
    int ss;
  public:
    Quadrat(int,int,int,int);
    int s() {return ss;};
    void zeichnen(int);
}; // Quadrat

class Kreis_und_Quadrat:
  public Kreis,public Quadrat
{ public:
    Kreis_und_Quadrat(int,int,int,int);
    void zeichnen(int);
}; // Kreis_und_Quadrat

// ********** Implementierung von Pixel ********

Pixel::Pixel(int x,int y,int f):
  Ort(x,y),ff(f)
{ } // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

// ********** Implementierung von Kreis ********

void Kreis::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  circle(xx,yy,rr);
} // Kreis::zeichnen

// ********** Implementierung von Quadrat ******
Quadrat::Quadrat(int x,int y,int f,int s):
  Pixel(x,y,f)
{ ss=s;
} // Quadrat::Quadrat

void Quadrat::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  int ss2=ss/2;
  moveto(xx-ss2,yy-ss2);
  lineto(xx+ss2,yy-ss2);
  lineto(xx+ss2,yy+ss2);
  lineto(xx-ss2,yy+ss2);
  lineto(xx-ss2,yy-ss2);
} // Quadrat::zeichnen

// ********** Kreis_und_Quadrat ****************
Kreis_und_Quadrat::Kreis_und_Quadrat
  (int x,int y,int f,int g):
  Kreis(x,y,f,g),Quadrat(x,y,f,g),Pixel(x,y,f)
  { } // Kreis_und_Quadrat::Kreis_und_Quadrat

void Kreis_und_Quadrat::zeichnen(int sichtbar)
{ Kreis::zeichnen(sichtbar);
  Quadrat::zeichnen(sichtbar);
} // Kreis_und_Quadrat::zeichnen

// ********** Hauptprogramm ********************

void main()
{ int karte=DETECT,modus,i;
  initgraph(&karte,&modus,BGI);
  Kreis_und_Quadrat kq(300,30,3,25);
  kq.zeichnen(1);
  for (i=1;i<=150;i++)
  { kq.bewegen(1,1);
    delay(100);
  }
  closegraph();
} // b076c
