// Beispiel 8.4D
/* Mehrere Turtles */
#include <graphics.h>
#include <dos.h>
#include <math.h>
const char BGI [ ] = "c:\\bc\\bgi";
class Ort
{ protected:
    int xx,yy;
  public:
    Ort(int x,int y) {xysetzen(x,y);};
    void xysetzen(int x,int y) {xx=x; yy=y;};
    int x()
      {return xx;};
    int y()
      {return yy;};
}; // Ort

class Pixel: public Ort
{ protected:
    int ff;
  public:
    Pixel(int x,int y,int f);
    void fsetzen(int f) {ff=f;};
    int f() {return ff;};
    void zeichnen(int sichtbar);
    void bewegen(int dx=1,int dy=1);
}; // Pixel

class Turtle: public Pixel
{ protected:
    float ww;
    int sichtbar;
  public:
    Turtle (int x=getmaxx()/2,int y=getmaxy()/2,
      int f=getmaxcolor(),int w=90):
      Pixel(x,y,f)
      { ww=w/180.0*M_PI;
	sichtbar=1;
      };
    void drehe(int dw) {ww+=dw/180.0*M_PI;};
    int w() {return ww*180.0/M_PI;};
    void gehe(int ds);
    void penup() {sichtbar=0;}
    void pendown() {sichtbar=1;};
}; // Turtle

class Pfeil: virtual public Pixel
{ protected:
    float ww;
  public:
    Pfeil (int x,int y,int f,int w):
      Pixel(x,y,f) { ww=w/180.0*M_PI; };
    void richtung(int w) {ww=w/180.0*M_PI;};
    int w() {return ww*180.0/M_PI;};
    void zeichnen(int sichtbar);
}; // Pfeil

class GTurtle: public Turtle,virtual public Pfeil
{ public:
    GTurtle(int x,int y,int f,int w):
      Turtle(x,y,f,w),Pfeil(x,y,f,w),Pixel(x,y,f) {};
    void gehe(int);
};

Pixel::Pixel(int x,int y,int f): Ort(x,y),ff(f)
{ } // Pixel::Pixel

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

void Turtle::gehe(int dw)
{ int xneu=xx+dw*cos(ww)+0.5;
  int yneu=yy+dw*sin(ww)+0.5;
  if (sichtbar)
  { setcolor(f());
    line(xx,yy,xneu,yneu);
  }
  xysetzen(xneu,yneu);
} // Turtle::gehe

void Pfeil::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  int dx=8*cos(ww);
  int dy=8*sin(ww);
  int xs=x()+dx,ys=y()+dy; // Spitze
  line(x(),y(),xs,ys);
  dx=-5*sin(ww);
  dy=5*cos(ww);
  line(xs,ys,x()+dx,y()+dy);
  line(xs,ys,x()-dx,y()-dy);
} // Pfeil::zeichnen

void GTurtle::gehe(int dw)
{ Pfeil::zeichnen(0);
  Turtle::gehe(dw);
  Pfeil::zeichnen(1);
} // GTurtle::gehe

void main()
{ int karte=DETECT,modus,j;
  initgraph(&karte,&modus,BGI);
  GTurtle t(200,200,15,90);
//  Pfeil p(t.x(),t.y(),t.f(),t.w());
//  p.zeichnen(1);
  for (j=1;j<=20;j++)
  { t.gehe(10);
    t.drehe(10);
    delay(300);
  }
} // b084d
