// Beispiel 10.3D
/* Doppelt verkette Liste */

#include <stdlib.h>
#include <iostream.h>

class Liste;
typedef Liste *PListe;
typedef void PrListe(PListe);
class Liste
{   PListe v; // vorheriges
    PListe n; // nchstes
  public:
    Liste() { v=(n=NULL); };
    virtual ~Liste() { };
    int leer() { return n==NULL; };
    int anzahl();
    void einf_vorne(PListe p);
    void einf_hinten(PListe p);
    void einf_vor(PListe p,PListe wo);
    void einf_nach(PListe p,PListe wo);
    void entf(PListe was);
    virtual void drucke();
    void aktion_vorw(PrListe was);
    void aktion_rueckw(PrListe was);
    PListe erstes() { return n; };
    PListe letztes() { return v; };
}; // Liste

void fehler(char *mldg)
{ cout << "\nFehler: " << mldg << "\n";
} // fehler

int Liste::anzahl()
{ if (leer()) return 0;
  else return n->anzahl() + 1;
} // Liste::anzahl

void Liste::einf_vorne(PListe p)
{ if (leer()) v=p;
  else n->v=p;
  p->n=n;
  n=p;
  p->v=NULL;
} // Liste::einf_vorne

void Liste::einf_hinten(PListe p)
{ if (leer()) n=p;
  else v->n=p;
  p->v=v;
  v=p;
  p->n=NULL;
} // Liste::einf_hinten

void Liste::einf_vor(PListe p,PListe wo)
{ if(!wo) einf_hinten(p);
  else
    if (!(wo->v)) einf_vorne(p);
    else
    { p->v=wo->v;
      p->n=wo;
      wo->v->n=p;
      wo->v=p;
    }
} // Liste::einf_vor

void Liste::einf_nach(PListe p,PListe wo)
{ if(!wo) einf_vorne(p);
  else
    if (!(wo->n)) einf_hinten(p);
    else
    { p->n=wo->n;
      p->v=wo;
      wo->n->v=p;
      wo->n=p;
    }
} // Liste::einf_nach

void Liste::entf(PListe was)
{ if (!was) return;
  if (was->v)
  { was->v->n=was->n;
    if (was->n)
      was->n->v=was->v;
    else
      v=was->v; // kein Nachfolger
  }
  else // erstes Element:
  { n=was->n;
    if (was->n)
      was->n->v=NULL;
  }
  delete(was);
} // Liste::entf

void Liste::drucke()
{ fehler("Fehler: Liste.drucke();");
  exit(1);
} // Liste::drucke

void Liste::aktion_vorw(PrListe was)
{ PListe p=n;
  while(p)
  { was(p);
    p=p->n;
  }
} // Liste::aktion_vorw

void Liste::aktion_rueckw(PrListe was)
{ PListe p=v;
  while(p)
  { was(p);
    p=p->v;
  }
} // Liste::aktion_rueckw

class IntEl;
typedef IntEl *PIntEl;
class IntEl: public Liste
{   int e;
  public:
    IntEl(int e) { IntEl::e=e; };
    virtual void drucke();
}; // IntEl

void IntEl::drucke()
{ cout.width(5);
  cout << e;
} // IntEl::drucke

class FloatEl;
typedef FloatEl *PFloatEl;
class FloatEl: public Liste
{   float e;
  public:
    FloatEl(float e) { FloatEl::e=e; };
    virtual void drucke();
}; // FloatEl

void FloatEl::drucke()
{ cout.width(5);
  cout << e;
} // FloatEl::drucke

void ausgabe(PListe p)
{ p->drucke();
} // ausgabe

void main()
{ Liste l;
  int i;
  PIntEl p;
  for (i=1; i<=3; i++)
  { p=new IntEl(i);
    l.einf_hinten(p);
  }
  for (i=4; i<=6; i++)
    l.einf_vorne(new FloatEl(i));
  l.einf_vor(new IntEl(7),p);
  l.einf_vor(new IntEl(8),NULL);
  l.einf_vor(new IntEl(9),l.erstes());
  l.einf_vor(new IntEl(10),l.letztes());
  l.einf_nach(new IntEl(11),p);
  l.einf_nach(new IntEl(12),NULL);
  l.einf_nach(new IntEl(13),l.erstes());
  l.einf_nach(new IntEl(14),l.letztes());

  cout << "\n" << l.anzahl() << " Elemente:\n";
  l.aktion_vorw(ausgabe);
  l.entf(p);

  cout << "\n";
  l.aktion_vorw(ausgabe);
} // b103d
