// Anfang der Datei b113c.cpp
#include <graphics.h>
#include "b113c.h"

// ***** Implementierung von Ort **********

Ort::Ort(int x,int y)
{ xysetzen(x,y);
} // Ort::Ort

void Ort::xysetzen(int x,int y)
{ xx=x; yy=y;
} // Ort::xysetzen

int Ort::x()
{ return xx;
} // Ort::x

int Ort::y()
{ return yy;
} // Ort::y

// ***** Implementierung von Pixel ********

Pixel::Pixel(int x,int y,int f):
  Ort(x,y),ff(f)
{ } // Pixel::Pixel

int Pixel::f()
{ return ff;
} // Pixel::f

void Pixel::zeichnen(int sichtbar)
{ if (sichtbar) putpixel(x(),y(),f());
  else putpixel(x(),y(),getbkcolor());
} // Pixel::zeichnen

void Pixel::bewegen(int dx,int dy)
{ zeichnen(0);
  xysetzen(x()+dx,y()+dy);
  zeichnen(1);
} // Pixel::bewegen

// ***** Implementierung von Kreis ********

Kreis::Kreis(int x,int y,int f,int r):
  Pixel(x,y,f),rr(r)
{ } // Kreis::Kreis

void Kreis::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  circle(xx,yy,rr);
} // Kreis::zeichnen

// ***** Implementierung von Quadrat ******

Quadrat::Quadrat(int x,int y,int f,int s):
  Pixel(x,y,f)
{ ss=s;
} // Quadrat::Quadrat

void Quadrat::zeichnen(int sichtbar)
{ if (sichtbar) setcolor(f());
  else setcolor(getbkcolor());
  int ss2=ss/2;
  moveto(xx-ss2,yy-ss2);
  lineto(xx+ss2,yy-ss2);
  lineto(xx+ss2,yy+ss2);
  lineto(xx-ss2,yy+ss2);
  lineto(xx-ss2,yy-ss2);
} // Quadrat::zeichnen

// Ende der Datei b113c.cpp

