// Beispiel 11.6B
/* Doppelt verkettete Liste */

#include <stdlib.h>
#include <iostream.h>

class Liste;
typedef Liste *PListe;
typedef void PrListe(PListe);

class Liste
{   PListe v; // vorheriges
    PListe n; // nchstes
  public:
    Liste() { v=(n=NULL); };
    virtual ~Liste() { };
    int leer() { return n==NULL; };
    int anzahl();
    void einf_vorne(PListe p);
    void einf_hinten(PListe p);
    virtual void drucke();
    void aktion_vorw(PrListe was);
    void aktion_rueckw(PrListe was);
}; // Liste

template <class Typ>
  class El: public Liste
{   Typ e;
  public:
    El(Typ e); // oder: { El<Typ>::e=e; };
    virtual void drucke();
}; // El

int Liste::anzahl()
{ if(leer()) return 0;
  else return n->anzahl()+1;
} // Liste::anzahl

void Liste::einf_vorne(PListe p)
{ if (leer()) v=p;
  else n->v=p;
  p->n=n;
  n=p;
  p->v=NULL;
} // Liste::einf_vorne

void Liste::einf_hinten(PListe p)
{ if (leer()) n=p;
  else v->n=p;
  p->v=v;
  v=p;
  p->n=NULL;
} // Liste::einf_hinten

void Liste::drucke()
{ cout << "Fehler: liste.drucke();\n";
  exit(1);
} // Liste::drucke

void Liste::aktion_vorw(PrListe was)
{ PListe p=n;
  while(p)
  { was(p);
    p=p->n;
  }
} // Liste::aktion_vorw

void Liste::aktion_rueckw(PrListe was)
{ PListe p=v;
  while(p)
  { was(p);
    p=p->v;
  }
} // Liste::aktion_rueckw

template <class Typ>
  El<Typ>::El (Typ e)
{ El<Typ>::e=e;
} // El<Typ>::El<Typ>

template <class Typ>
  void El<Typ>::drucke()
{ cout.width(5);
  cout << e;
} // IntEl::drucke

void ausgabe(PListe p)
{ p->drucke();
} // ausgabe

typedef El<int> IntEl;
typedef El<char> CharEl;

void main()
{ Liste l;
  int i;
  for (i=1; i<=5; i++)
    l.einf_vorne(new IntEl(i));
  for (i='F'; i<='J'; i++)
    l.einf_hinten(new CharEl(i));

  cout << "\n" << l.anzahl()
    << " Elemente:\n";
  l.aktion_vorw(ausgabe);
  cout << "\n";
  l.aktion_rueckw(ausgabe);
  cout << "\n";
} // b116b
