// Beginn der Datei bgi_oo.cpp = b131a.cpp
#include "b131a.h"
#include <dos.h>
#include <conio.h>

// Statische Variablen der Graphik
unsigned Graphik::x_max_vm;
unsigned Graphik::y_max_vm;
unsigned Graphik::farbanzahl_vm;
unsigned Graphik::x_mitte_vm;
unsigned Graphik::y_mitte_vm;
int Graphik::initialisiert=0;

//-----------------------------------------------
// Methoden der Klasse Graphik
//-----------------------------------------------

//---- Graphikmodus initialisieren --------------
Graphik::Graphik
  (char *bgi_pfad,int treiber,int modus)
{ if (!initialisiert)
  { initgraph(&treiber,&modus,bgi_pfad);
    x_max_vm=getmaxx();
    y_max_vm=getmaxy();
    farbanzahl_vm=getmaxcolor();
    x_mitte_vm=(x_max_vm+1)/2;
    y_mitte_vm=(y_max_vm+1)/2;
    initialisiert=1;
  }
} // Graphik::Graphik

//---- Abbildung definieren ---------------------
float Graphik::x_abb(float x)
{ return x;
} // Graphik::x_abb

float Graphik::y_abb(float y)
{ return y;
} // Graphik::y_abb

//---- Inverse Abbildung definieren -------------
float Graphik::x_invabb(float xbild)
{ return xbild;
} // Graphik::x_invabb

float Graphik::y_invabb(float ybild)
{ return ybild;
} // Graphik::y_invabb

//---- Abbildungsgleichung Welt>Screen ----------
int Graphik::xPix(float x)
{ return x_abb(x);
} // Graphik::xPix

int Graphik::yPix(float y)
{ return y_abb(y);
} // Graphik::yPix

//---- Inverse Abbildung Screen>Welt ------------
float Graphik::xKoord(int xfenster)
{ return x_invabb(xfenster);
} // Graphik::xKoord

float Graphik::yKoord(int yfenster)
{ return y_invabb(yfenster);
} // Graphik::yKoord

//---- Warten auf einen Tastendruck -------------
void Graphik::warte_auf_taste(void)
{ while (kbhit()) getch();
  if (!getch()) getch();
} // Graphik::warte_auf_taste

//---- Graphikmodus beenden ---------------------
void Graphik::bgi_end()
{ initialisiert=0;
  closegraph();
} // Graphik::bgi_end

//-----------------------------------------------
// Methoden der Klasse Screen
//-----------------------------------------------

Screen::Screen(int xur,int yur,int farbe):
  Graphik()
{ x_ursprung=xur;
  y_ursprung=yur;
  setbkcolor(farbe);
} // Screen::Screen

//---- Abbildungsgleichung fr Screen -----------
float Screen::x_abb(float x)
{ return x_ursprung+x;
} // Ccreen::x_abb

float Screen::y_abb(float y)
{ return y_ursprung-y;
} // Screen::y_abb

//---- Inverse Abbildung fr Screen -------------
float Screen::x_invabb(float xbild)
{ return xbild-x_ursprung;
} // Screen::x_invabb

float Screen::y_invabb(float ybild)
{ return ybild-y_ursprung;
} // Screen::y_invabb

//---- Zeichnen der Koordinatenachsen -----------
void Screen::achsen(unsigned farbe)
{ // Sichern der aktuellen Zeichenfarbe
  unsigned alte_farbe=getcolor();
  setcolor(farbe);
  line(0,y_ursprung,x_max_vm,y_ursprung);
  line(x_ursprung,0,x_ursprung,y_max_vm);

  // Wiederherstellen der Zeichenfarbe
  setcolor(alte_farbe);
} // Screen::achsen

//-----------------------------------------------
// Methoden der Klasse Fenster
//-----------------------------------------------

Fenster::Fenster
    (float xwlo,float ywlo,float xwru,float ywru,
    int xflo,int yflo,int xfru,int yfru,
    int bkfarbe,int rfarbe):Screen(0,0)
{ x_weite_welt=xwru-xwlo;
  y_weite_welt=ywlo-ywru;
  x_weite_fenster=xfru-xflo;
  y_weite_fenster=yfru-yflo;
  x_abbfaktor=x_weite_fenster/x_weite_welt;
  y_abbfaktor=y_weite_fenster/y_weite_welt;
  setfillstyle(1,bkfarbe);
  setviewport(0,0,x_max_vm,y_max_vm,!CLIP_ON);
  bar(xflo-5,yflo-5,xfru+5,yfru+5);
  setcolor(rfarbe);
  rectangle(xflo,yflo,xfru,yfru);
  if (xflo<0) xflo=0;
  if (yflo<0) yflo=0;
  if (xfru>x_max_vm) xfru=x_max_vm;
  if (yfru>y_max_vm) yfru=y_max_vm;
  x_absflo=xflo; y_absflo=yflo;
  x_absfru=xfru; y_absfru=yfru;
  fensteraktiv();
  x_ursprung=-xwlo*x_abbfaktor;
  y_ursprung=ywlo*y_abbfaktor;
} // Fenster::Fenster

//---- Fenster reaktivieren ---------------------
void Fenster::fensteraktiv()
{ setviewport(x_absflo,y_absflo,x_absfru,y_absfru,CLIP_ON);
} // Fenster::fensteraktiv

//---- Abbildungsgleichungen fr Fenster --------
float Fenster::x_abb(float x)
{ return Screen::x_abb(x*x_abbfaktor);
} // Fenster::x_abb

float Fenster::y_abb(float y)
{ return Screen::y_abb(y*y_abbfaktor);
} // Fenster::y_abb

//---- Inverse Abbildung fr Fenster ------------
float Fenster::x_invabb(float xbild)
{ return Screen::x_invabb(xbild/x_abbfaktor);
} // Fenster::x_invabb

float Fenster::y_invabb(float ybild)
{ return Screen::y_invabb(ybild/y_abbfaktor);
} // Fenster::y_invabb

//---- Koordinatenachsen darstellen -------------
void Fenster::achsen(float xmin,float xmax,
    float ymin,float ymax,unsigned farbe)
{ unsigned aktfarbe=getcolor();
  setcolor(farbe);
  line(xPix(xmin), yPix(0), xPix(xmax), yPix(0));
  line(xPix(0), yPix(ymin), xPix(0), yPix(ymax));
  setcolor(aktfarbe);
} // Fenster::achsen
// Ende der Datei bgi_oo.cpp = b131a.cpp
