// Anfang der Datei b133a.cpp

#include "b133a.h"
#include <conio.h>
#include <dos.h>
#include <graphics.h>

//---- Implementierung der Methoden Maus --------
//---- reset ------------------------------------
Maus::Maus()
{ REGS reg;
  reg.x.ax=0;
  int86(0x33,&reg,&reg);
  MausnotOK=!reg.x.ax;
} // Maus::Maus

//---- Maus OK ? --------------------------------
int Maus::notOK()
{ return MausnotOK;
} // Maus::notOK

//---- Mauskoordinaten ermitteln ----------------
int Maus::xWo(int xxwo)
{ return xxwo;
} // Maus::xWo

int Maus::yWo(int yywo)
{ return yywo;
} // Maus::yWo

//---- Inverse Abbildung ------------------------
int Maus::xInvWo(int xxwo)
{ return xxwo;
} // Maus::xInvWo

int Maus::yInvWo(int yywo)
{ return yywo;
} // Maus::yInvWo

//---- Mausposition ermitteln -------------------
void Maus::pos(int& xpos,int& ypos,int& taste)
{ REGS reg;
  reg.x.ax=3;
  int86(0x33,&reg,&reg);
  taste=reg.x.bx;
  xpos=xWo(reg.x.cx);
  ypos=yWo(reg.x.dx);
} // Maus::pos

//---- Aktuelle x Position ----------------------
int Maus::x()
{ REGS reg;
  reg.x.ax=3;
  int86(0x33,&reg,&reg);
  return xWo(reg.x.cx);
} // Maus::x

//---- Aktuelle y Position ----------------------
int Maus::y()
{ REGS reg;
  reg.x.ax=3;
  int86(0x33,&reg,&reg);
  return yWo(reg.x.dx);
} // Maus::y

//---- Aktueller Tastenstatus -------------------
int Maus::t()
{ REGS reg;
  reg.x.ax=3;
  int86(0x33,&reg,&reg);
  return reg.x.bx;
} // Maus::t

//---- Maus positionieren------------------------
void Maus::setzen(int xpos,int ypos)
{ // Interrupt 0x33, Function 4
  // Setzt den Mauszeiger in (xpos,ypos)
  REGS reg;
  reg.x.ax=4;
  reg.x.cx=xInvWo(xpos);
  reg.x.dx=yInvWo(ypos);
  int86(0x33,&reg,&reg);
} // maus::setzen

//---- Mauszeiger ein- und ausschalten ----------
void Maus::zeigen(int wahl)
{ // wahl : 1   Mauscursor sichtbar
  //        0   Mauscursor unsichtbar
  REGS reg;
  if (wahl && !sichtbar)
  { reg.x.ax=1;
    sichtbar=1;
    int86(0x33,&reg,&reg);
  }
  else
    if (sichtbar && !wahl)
    { reg.x.ax=2;
      sichtbar=0;
      int86(0x33,&reg,&reg);
    }
} // Maus::zeigen

//---- Maustastendruck abfragen -----------------
void Maus::tasteDruck(int taste,MAkt& mp)
{ REGS reg;
  reg.x.ax=5;
  reg.x.bx=taste;
  int86(0x33,&reg,&reg);
  mp.tastenStatus=reg.x.ax;
  mp.aktionen=reg.x.bx;
  mp.xPos=xWo(reg.x.cx);
  mp.yPos=yWo(reg.x.dx);
} // Maus::tasteDruck

//---- Maustastenfreigabe abfragen --------------
void Maus::tasteLos(int taste,MAkt& mp)
{ REGS reg;
  reg.x.ax=6;
  reg.x.bx=taste;
  int86(0x33,&reg,&reg);
  mp.tastenStatus=reg.x.ax;
  mp.aktionen=reg.x.bx;
  mp.xPos=xWo(reg.x.cx);
  mp.yPos=yWo(reg.x.dx);
} // Maus::tasteLos

//-- Lokale Funktionen fr die nchsten Methoden
static int min(int a,int b)
{ return a<b ? a : b;
} // min

static int max(int a,int b)
{ return a>b ? a : b;
} // max

static void vertausche(int& a,int& b)
{ int h=a;
  a=b; b=h;
} // vertausche

//----Schrnkt die Maus auf ein Rechteck ein ----
void Maus::grenzen(int x1,int y1,int x2,int y2)
{ REGS reg;
  reg.x.ax=7;
  reg.x.cx=xInvWo(min(x1,x2));
  reg.x.dx=xInvWo(max(x1,x2));
  int86(0x33,&reg,&reg);

  reg.x.ax=8;
  reg.x.cx=yInvWo(min(y1,y2));
  reg.x.dx=yInvWo(max(y1,y2));
  int86(0x33,&reg,&reg);
} // Maus::grenzen

//-- berprft ob die Maus in einem Rechteck ist
int Maus::innen(int x1,int y1,int x2,int y2)
{ int xpos,ypos,tt;
  // Ordnen der Grenzen:
  if (x1>x2) vertausche(x1,x2);
  if (y1>y2) vertausche(y1,y2);

  // Aktuelle Mausposition ermitteln
  pos(xpos,ypos,tt);

  // Abfrage
  return xpos>=x1 && xpos<=x2
    && ypos>=y1 && ypos<=y2;
} // Maus::innen

//---- Implementation von GMaus -----------------
GMaus::GMaus():Maus()
{ sichtbar=0;
  grenzen(0,0,getmaxx(),getmaxy());
  cursor(kreuz);
  setzen(100,100);
  zeigen(1);
} // GMaus::GMaus

//---- Graphikmauscursor definieren -------------
void GMaus::cursor(Gcursor ctyp)
{ REGPACK reg;
  reg.r_ax=9;
  reg.r_bx=ctyp.xHot;
  reg.r_cx=ctyp.yHot;
  reg.r_dx=FP_OFF(ctyp.screenMaske);
  reg.r_es=FP_SEG(ctyp.screenMaske);
  intr(0x33,&reg);
} // GMaus::cursor

//---- Implementation der Methoden TMaus---------
TMaus::TMaus() : Maus()
{ sichtbar=0;
  text_info r;
  gettextinfo(&r);
  grenzen(r.winleft+1,r.winbottom+1,
    r.winright+1,r.wintop+1);
  cursor(Hardware,6,7);
  setzen(1,1);
  zeigen(1);
} // TMaus::TMaus

//---- Textmaus cursor setzen -------------------
void TMaus::cursor(unsigned ctyp,unsigned sMaske,
  unsigned cMaske)
{ REGS reg;
  reg.x.ax=0x0A;
  reg.x.bx=ctyp;
  reg.x.cx=sMaske;
  reg.x.dx=cMaske;
  int86(0x33,&reg,&reg);
} // TMaus::cursor

//---- Abbildungsmethoden fr die Textmaus ------
int TMaus::xWo(int xxwo)
{ return (xxwo/8)+1;
} // TMaus::xWo

int TMaus::yWo(int yywo)
{ return (yywo/8)+1;
} // TMaus::yWo

int TMaus::xInvWo(int xxwo)
{ return (xxwo-1) << 3;
} // TMaus::xInvWo

int TMaus::yInvWo(int yywo)
{ return (yywo-1) << 3;
} // TMaus::yInvWo

// Ende der Datei maus_oo = b133a
