// Beispiel 13.3B
/* Anwendung der Maus */
#include <conio.h>
#include <dos.h>
#include <graphics.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>
#include "b131a.h"
#include "b133a.h"

const char BGI [ ] = "c:\\bc\\bgi";

//---- Zeichnen eines Rahmens im Textmodus ------
void rahmen(int xlo,int ylo,
  int xru,int yru,int hg,int rf)
{ /* Ein mit der Hintergrundfarbe hg gefllter
     Rahmen mit der Farbe rf, mit (xlo,ylo) als
     linke obere und (xru,yru) als rechte Ecke
     wird gezeichnet */
  unsigned char l,b,rzeile,tAttrSave;
  char st[81];

  // Sichern der aktuellen Textattribute
  text_info ti;
  gettextinfo(&ti);
  tAttrSave=ti.attribute;

  textattr((hg << 4)+rf);

  // Rahmengre
  l=xru-xlo+1;
  b=yru-ylo;

  // Zeilenweises Zeichnen eines Rahmens
  // 1.Zeile
  setmem(st+1,l-2,0xc4); // st mit 0xc4 fllen
  st[0]=0xda;    // erstes Zeichen ''
  st[l-1]=0xbf;  // letztes Zeichen ''
  st[l]=0;       // Abschlu
  gotoxy(xlo,ylo); puts(st);

  setmem(st+1,l-2,' '); // st mit ' ' fllen
  st[0]=0xb3;    // erstes Zeichen ''
  st[l-1]=0xb3;  // letztes Zeichen ''
  st[l]=0;       // Abschlu

  for(rzeile=1;rzeile<=b-1;rzeile++)
  { gotoxy(xlo,rzeile+ylo);
    puts(st);
  }

  // Letzte Zeile
  setmem(st+1,l-2,0xc4); // st mit 0xc4 fllen
  st[0]=0xc0;    // erstes Zeichen ''
  st[l-1]=0xd9;  // letztes Zeichen ''
  st[l]=0;       // Abschlu
  gotoxy(xlo,yru); puts(st);

  // Alte Attribute wieder herstellen
  textattr(tAttrSave);
} // rahmen

//---- Darstellung des Auswahlmens im Textmodus
void textmenu(TMaus &tm)
{ textbackground(CYAN);
  clrscr();

  tm.cursor(Software,0x74ff,0x7f00);
  tm.grenzen(2,2,79,24);
  tm.zeigen(0);

  // Men darstellen
  rahmen(23,2,34,10,LIGHTGRAY,RED);
  textcolor(BLUE);
  gotoxy(25,4); puts("EIN");
  gotoxy(26,6); puts("kleines");
  gotoxy(27,8); puts("MEN");
  textcolor(YELLOW);

  rahmen(40,5,50,9,BLUE,BROWN);
  gotoxy(43,7); puts("Malen");
  rahmen(40,12,50,16,BLUE,BROWN);
  gotoxy(43,14); puts("Linien");
  rahmen(40,19,50,23,BLUE,RED);
  gotoxy(43,21); puts("Ende");
  gotoxy(2,19); puts("  <xpos><ypos><taste>");
  tm.zeigen(1);
} // textmenu

//---- Malen mit der Maus
void malenmitmaus()
{ Graphik g(BGI);
  Screen s(10,s.y_mitte(),LIGHTGRAY);
  GMaus gm;
  int x_pos,y_pos,maus_taste,xa,ya;
  gm.grenzen(50,50,getmaxx()-50,getmaxy()-50);

  outtextxy(10,10,
    "Ende mit rechter Maustaste - Klick!");
  outtextxy(10,20,
    "Zeichnen mit gehaltener linker Maustaste!");

  gm.cursor(hand);
  gm.zeigen(1);     // Maus auch herzeigen
  setcolor(YELLOW); // Linienfarbe

  do // bis ein Ereignis eintritt
  { gm.pos(x_pos,y_pos,maus_taste);
    // wo ist die Maus ? Status ?
    if (maus_taste==linkeTaste)
    { // wenn linke Maustaste gedrckt
      moveto(x_pos,y_pos);
      // Graphikcursor an den Linienanfang
      xa=x_pos; ya=y_pos;
      // Merken der aktuellen Mausposition

      do
      { // solange die linke Maustaste gedrckt
	gm.pos(x_pos,y_pos,maus_taste);
	// Aktuelle Mausposition
	if (x_pos!=xa || y_pos!=ya)
	// wenn sich die Pos. verndert hat
	{ // Vor einem Zeichenbefehl ist der
	  // Mauszeiger immer zu verstecken, da
	  // sonst die Mausmaske "mitarbeitet"
	  gm.zeigen(0);
	  lineto(x_pos,y_pos);
	  gm.zeigen(1);
	  // Aktuelle Mausposition merken
	  xa=x_pos; ya=y_pos;
	}
      } while (maus_taste!=keineTaste);
      // endlich losgelassen
    }
  } while (maus_taste!=rechteTaste);
  // wenn rechts gedrckt: Ausstieg

  while(gm.t()!=keineTaste);
  // Warten, bis Maustaste losgelassen
  s.bgi_end();
} // malenmitmaus

//---- Zeichnen von Linie im XOR-Modus
void xorline(int xs,int ys,int xe,int ye)
{ setwritemode(XOR_PUT);
  line(xs,ys,xe,ye);
  setwritemode(COPY_PUT);
} // xorline

//---- Zeichnen von Gummilinien -----------------
void gummilinie
  (unsigned gummi_f,unsigned linien_f)
{ Graphik g(BGI);
  Screen s(10,s.y_mitte(),LIGHTGRAY);
  GMaus gm;
  int maus_taste;
  char st[80];
  int x_anf,y_anf,x_end,y_end,x_wo,y_wo;
  outtextxy(10,10,
    "Ende: beide Maustasten klicken!");
  strcpy(st,
  "Start-,Endpunkt:je linke Maustaste klicken!");
  outtextxy(10,20,st);

  gm.cursor(kreuz);
  gm.grenzen(100,100,500,350);
  gm.zeigen(1);

  do
  { // Wiederhole, bis was passiert
    gm.pos(x_anf,y_anf,maus_taste);
    // Aktuelle Mausposition

    if (maus_taste==linkeTaste)
    { // Linke Taste gedrckt
      while(gm.t()!=keineTaste);
      // warte, bis losgelassen
      x_wo=x_anf; y_wo=y_anf;
      // aktuelle Masuposition merken
      setcolor(gummi_f);

      do // bis linke Taste erneut gedrckt
      { gm.pos(x_end,y_end,maus_taste);
	// was ist los
	if (x_end!=x_wo || y_end!=y_wo)
	{ // Maus wurde bewegt
	  gm.zeigen(0);
	  // Mauscursor verstecken
	  xorline(x_anf,y_anf,x_wo,y_wo);
	  // Linie im XOR-Modus zeigen
	  x_wo=x_end; y_wo=y_end;

	  // aktuelle Mausposition merken
	  xorline(x_anf,y_anf,x_end,y_end);
	  // gezeichnete Linie lschen
	  gm.zeigen(1);
	  // Mauscursor wieder zeigen
	}
      } while (maus_taste!=linkeTaste);

      // warte, bis losgelassen
      while(gm.t()!=keineTaste);
      // Nun die Linie wirklich zeichnen
      setcolor(linien_f);
      gm.zeigen(0);
      line(x_anf,y_anf,x_end,y_end);
      gm.zeigen(1);
    }
  } while (maus_taste!=beideTasten);
  // Beide Tasten gedrckt

  while (gm.t()!=keineTaste);
  s.bgi_end();

} // gummilinie

void main()
{ TMaus tm;
  if (tm.notOK())
  { printf("Maus nicht gefunden\n");
    exit(1);
  }

  // Men aktivieren
  textmenu(tm);

  int x,y,t;
  while (1)
  { tm.pos(x,y,t);
    tm.zeigen(0);
    gotoxy(2,20);
    cprintf("%6d%6d%6d",x,y,t);
    tm.zeigen(1);
    delay(10);
    // wurde die linke Taste gedrckt?
    if (t==1)
    { tm.zeigen(0);
      // Abfrage, ob der Mauscursor
      // in einem Rahmen ist
      if (tm.innen(40, 5,50, 9))
      {	malenmitmaus();
      }
      if (tm.innen(40,12,50,16))
      { gummilinie(BLUE,RED);
      }
      if (tm.innen(40,19,50,23))
	break;
      textmenu(tm);
      tm.setzen(x,y);
      tm.zeigen(1);
    }
  }
} // b133b
