// Beispiel 13.5B
/* Bilder speichern */

// #include <stdio.h>
#include <dos.h>
#include <fcntl.h>
#include <sys\stat.h>
#include <io.h>
#include "b131a.h"

const char BGI [ ] = "c:\\bc\\bgi";
const unsigned scrSeg=0xa000;
unsigned screenBreite;

void sPic(unsigned xlo,unsigned ylo,
  unsigned xru,unsigned yru,char *fn)
{ int f;
  unsigned char plane;
  f=open(fn,O_WRONLY|O_CREAT|O_BINARY,S_IWRITE);
  unsigned offset=screenBreite*ylo + xlo/8;
  unsigned bytesProZeile=xru/8 - xlo/8 + 1;
  unsigned anzahlZeilen=yru-ylo+1;
  unsigned z;
  // Schreiben der Ausschnittsgre
  const unsigned laenge=sizeof(unsigned);
  _dos_write(f,&bytesProZeile,laenge,&z);
  _dos_write(f,&anzahlZeilen,laenge,&z);

  outportb(0x3ce,4);
  // Index Read Map Select Register
  // Zhlschleife fr Rasterzeilen

  for (unsigned y=ylo;y<=yru;y++)
  { // Zhlschleife der Bitplanes:
    for (plane=0;plane<=3;plane++)
    { // Bitplane auswhlen:
      outportb(0x3cf,plane);
      // Zeile aus der Bitplane schreiben
      _dos_write(f,MK_FP(scrSeg,offset),
	bytesProZeile,&z);
    }
    offset+=screenBreite;
  }

  outportb(0x3cf,0);
  // Read Map Register zurcksetzen
  close(f); // Datei schlieen
} // sPic

void lPic(unsigned xlo,unsigned ylo,char *fn)
{ int f;
  unsigned char plane;
  f=open(fn,O_RDONLY|O_BINARY);
  unsigned offset=screenBreite*ylo + xlo/8;
  unsigned bytesProZeile;
  unsigned anzahlZeilen,z;
  // Lesen Dateikopf
  const unsigned laenge=sizeof(unsigned);
  _dos_read(f,&bytesProZeile,laenge,&z);
  _dos_read(f,&anzahlZeilen,laenge,&z);

  unsigned yru=ylo + anzahlZeilen - 1;
  outportb(0x3c4,2);
  // Index fr Map Mask Register

  // Zhlschleife fr Rasterzeilen
  for (unsigned y=ylo;y<=yru;y++)
  { // Zhlschleife der Bitplanes:
    for (plane=0;plane<=3;plane++)
    { // Bitplane auswhlen:
      outportb(0x3c5,1 << plane);
      // Zeile in die Bitplane schreiben
      _dos_read(f,MK_FP(scrSeg,offset),
	bytesProZeile,&z);
    }
    offset+=screenBreite;
  }

  outportb(0x3c5,0xf);
  // Map Mask Register zurcksetzen
  close(f); // Datei schlieen
} // lPic

void main()
{ Graphik g(BGI);
  Screen s(10,s.y_mitte(),LIGHTGRAY);
  // Berechnen der Bytezahl fr eine Zeile
  screenBreite=(s.x_max()+1)/8;

  // Erzeugen einer kleinen LinienGraphik
  for (int t=0;t<=160;t++)
  { setcolor(8+t%4);
    line(s.xPix(3*t),s.yPix(50+t),
      s.xPix(600-3*t),s.yPix(100-2*t));
  }
  s.warte_auf_taste();

  // Speichern des Bildausschnittes im
  // Rechteck von (10,10) bis (600,400)
  // in der Datei BILD.PIC
  sPic(10,10,600,400,"BILD.PIC");

  // Fllen des Bildschirms mit rot
  setfillstyle(1,RED);
  floodfill(40,10,LIGHTBLUE);
  s.warte_auf_taste();

  // Laden des Bildschirmausschnittes
  // mit (30,30) als linker oberer
  // Ecke
  lPic(30,30,"BILD.PIC");
  s.warte_auf_taste();
  s.bgi_end();
} // b135b
